
/*

  Copy a ``original'' format file

*/

#include <stdio.h>
#include "datahdr.h"
#include "strmhdr.h"
#include "fstrmhdr.h"

static char *usage        = "USAGE: ocat <state> <infile> <outfile>\n" ;

extern void sums () ;

void get_params (state, file1, file2, argc, argv)
char **state, **file1, **file2 ;
int argc ;
char *argv [] ;
{
  if (argc != 4)
  {
    fprintf (stderr, usage) ;
    exit (1) ;
  }
  *state = argv [1] ;

  if (! strcmp (argv [2], "-"))
    *file1 = NULL ;
  else
    *file1 = argv [2] ;

  if (! strcmp (argv [3], "-"))
    *file2 = NULL ;
  else
    *file2 = argv [3] ;
}

void main (argc, argv)
int argc ;
char *argv [] ;
{
  char *state, *file1, *file2 ;
  DATA *datas ;
  DATA *data1, *data2 ;
  int   sparams [NUM_STT_PARAMS], params [128] ;
  float scoeffs [NUM_STT_COEFFS], coeffs [128] ;
  int l_time, l_space ;
  int num_params, num_coeffs ;

  get_params  (&state, &file1, &file2, argc, argv) ;

  datas = data_open_read (state) ;
  read_header     (datas) ;
  read_coeffs     (datas, scoeffs) ;
  read_params     (datas, sparams) ;
  data_close_read (datas) ;

  data1 = data_open_read (file1) ;
  read_header     (data1) ;
  read_coeffs     (data1, coeffs) ;
  read_params     (data1, params) ;

  data2 = data_open_write (file2) ;
  write_header (data2) ;
  write_coeffs (data2, NUM_DAT_COEFFS, coeffs) ;
  write_params (data2, NUM_DAT_PARAMS, params) ;

  l_time  = sparams [STT_L_T] ;
  l_space = sparams [STT_L_X] * sparams [STT_L_Y] * sparams [STT_L_Z] ;
  fprintf (stderr, "l_t = %d, l_s = %d\n", l_time, l_space) ;

  read_field_begin  (data1) ;
  write_field_begin (data2) ;
  copy (data1, data2, l_time, l_space) ;
  write_field_end   (data2) ;

  data_close_read  (data1) ;
  data_close_write (data2) ;

  exit (0) ;
}

